# Wherein I prove I don't know how to use a singleton

from math import sin, cos, exp, sqrt, pi
import settings
from OpenGL.GL import *
from OpenGL.GLU import gluLookAt

r = 240
phi, theta = 0.2, 0.2
mset = False
tower = None
cx, cy, cz = None, None, None
px, py, pz = None, None, None

def setangles():
    global Sphi, Cphi, Stheta, Ctheta, phi, theta
    if settings.levelname == "tutorial":
        phi, theta = pi, 0.
    Sphi, Cphi = sin(phi), cos(phi)
    Stheta, Ctheta = sin(theta), cos(theta)
setangles()

def move((dx, dy)):
    global mset, phi, theta
    if mset:
        phi -= dx * settings.msensitivity
        theta = min(max(0.05, theta - dy * settings.msensitivity), 1.5)
    else:
        mset = True
    setangles()

def zoomin(factor = 1.):
    global r
    r = max(r * 0.9 ** factor, 80)

def zoomout(factor = 1.):
    global r
    r = min(r / 0.9 ** factor, 450)

def look(dt):
    global cx, cy, cz, px, py, pz
    x = r * Sphi * Ctheta
    y = r * Cphi * Ctheta
    z = r * Stheta
    if cx is None:
        cx, cy, cz = x, y, z
        px, py, pz = tower.px, tower.py, tower.pz
    else:
        f = exp(-dt * 3.)
        g = 1. - f
        cx = f * cx + g * x
        cy = f * cy + g * y
        cz = f * cz + g * z
        px = f * px + g * tower.px
        py = f * py + g * tower.py
        pz = f * pz + g * tower.pz

    gluLookAt(px+cx, py+cy, pz+cz, px, py, pz, -cx * cz, -cy * cz, cx**2 + cy**2)
    cr = sqrt(cx ** 2 + cy ** 2 + cz ** 2)
    glFogf(GL_FOG_START, cr + 50.)
    glFogf(GL_FOG_END, cr + 350.)


def transform(x, y):
    return -(x * Cphi + y * Sphi), -(-x * Sphi + y * Cphi)



